% Figure1_8.m
% generates a differential frame by subtracting two 
% temporally adjacent intensity image frames
% quantizes the differential frame and reconstructs
% original frame by adding quantized differential frame 
% to the other frame.
close all
clear
Frm1 = 'tt120.ras'; 
Frm2 = 'tt121.ras'; 
I = imread(Frm1); % read frame # 120
I1 = im2single(I); % convert from uint8 to float single
I = imread(Frm2); % read frame # 121
figure,imhist(I,256),title(['Histogram of frame ' num2str(121)])
xlabel('Pixel Value'), ylabel('Pixel Count')
I2 = im2single(I); % convert from uint8 to float single
clear I
figure,imshow(I1,[]), title([num2str(120) 'th frame'])
figure,imshow(I2,[]), title([num2str(121) 'st frame'])
%
Idiff = imsubtract(I2,I1); % subtract frame 120 from 121
figure,imhist(Idiff,256),title('Histogram of difference image')
xlabel('Pixel Value'), ylabel('Pixel Count')
figure,imshow(Idiff,[]),title('Difference image')
% quantize and dequantize the differential image
IdiffQ = round(4*Idiff)/4;
figure,imshow(IdiffQ,[]),title('Quantized Difference image')
y = I1 + IdiffQ; % reconstruct frame 121
figure,imshow(y,[]),title('Reconstructed image')


