% CompandingQuantizer.m
%
clear
close all
A = imread('barbara.tif');
%A = imread('cameraman.tif');
[Height,Width,Depth] = size(A);
if Depth == 1
    f = double(A);
else
    f = double(A(:,:,1));
end
if Height>512 || Width > 512
    figure,imshow(uint8(f(60:275,302:585)))
    [Counts,Bins] = imhist(uint8(f(60:275,302:585)),256);
else
    figure,imshow(uint8(f))
    [Counts,Bins] = imhist(uint8(f),256);
end
title('Image quantized to 8 bits')
%
sigmaf = std2(f);
f1 = zeros(Height,Width);
f2 = zeros(Height,Width);
g = zeros(Height,Width);
CompanderLaw = 'mu'; % options: 'mu', 'a', and 'exp'
switch CompanderLaw
    case 'mu'
        mu = 255;
        V = 255;
        f1 = V*log(1+mu*f/V)/log(1+mu);
    case 'a'
        V = 255;
        A = 87.6;
        for i = 1:Height
            for j = 1:Width
                if(f(i,j)>=0 && f(i,j)<=V/A)
                    f1(i,j) = A*f(i,j)/(1+log(A));
                else
                    f1(i,j) = V*(1+log(A*f(i,j)/V))/(1+log(A));
                end
            end
        end
    case 'exp'
        V = 255;
        a = (exp(V)-1)/V;
        f1 = log(1+a*f);
end
B = 7;
snr = zeros(1,B);
for b = 7:7
    L = 2^b;
    q = V/L;
    
    q2 = q/2;
    d = linspace(0,V,L+1);
    r = zeros(L,1);
    for k = 1:L
        r(k) = d(k)+q2;
    end
    for k = 1:L
        [x,y] = find(f1>d(k) & f1<=d(k+1));
        for j = 1:length(x)
            f2(x(j),y(j)) = round(r(k));
            E(x(j),y(j)) = double(f1(x(j),y(j)))-r(k);% include surf plot
        end
    end
    
    %f2 = round(floor(f1/q + 0.5)*q);
    %f1 = (V/mu)*(exp(log(1+mu).*f2/V)-1);
    switch CompanderLaw
        case 'mu'
            g = (V/mu)*(((1+mu).^(f2/V))-1);
        case 'a'
            for i = 1:Height
                for j = 1:Width
                    if(f2(i,j)>=0 && f2(i,j)<=V/(1+log(A)))
                        g(i,j) = f2(i,j)*(1+log(A))/V;
                    else
                        g(i,j) = V*exp(f2(i,j)*(1+log(A))/V-1)/A;
                    end
                end
            end
        case 'exp'
            g = (exp(f2)-1)/a;
    end
    if b == 5
        E = f1 - f2;
        figure,subplot(2,1,1),plot(E(150,:),'k','LineWidth',2)
        title(['Quantization error: L = ' num2str(L)])
        xlabel('pixel # on row 150')
        ylabel('Quantization error')
        [Counts,Bins]= hist(E(150,:));
        subplot(2,1,2),plot(Bins,Counts,'k','LineWidth',2)
        title('Histogram of quantization error')
        xlabel('Error bins'), ylabel('Counts')
    end
        if b == 3 || b == 5
            if Height>512 || Width > 512
                figure,imshow(uint8(g(60:275,302:585)))
            else
                figure,imshow(uint8(g))
            end
            title(['Image quantized to ' num2str(b) ' bits'])
        end
   snr(b) = 20*log10(sigmaf/std2(f-g));
end

figure,plot(1:B,snr,'k','LineWidth',2)
title('SNR Vs Bits/pixel of a uniform quantizer')
xlabel('# bits')
ylabel('SNR(dB)')
