% Example2_1.m
% Resamples an original image to study the
% effects of undersampling
%
A = imread('barbara.tif');
[Height,Width,Depth] = size(A);
if Depth == 1
    f = A;
else
    f = A(:,:,1);
end
% downsample by a factor of M, no prefiltering
M = 4;
f1 = f(1:M:Height,1:M:Width);
figure,imshow(f1), title(['Downsampled by ' num2str(M) ':No prefiltering'])
f1 = imresize(f1,[Height,Width],'bicubic');%reconstruct to full size
figure,imshow(f1(60:275,302:585))
title('Reconstructed from downsampled image: No prefiltering')
%
% downsample by a factor of M, after prefiltering
% use a gaussian lowpass filter
f = imfilter(f,fspecial('gaussian',7,2.5),'symmetric','same');
f1 = f(1:M:Height,1:M:Width);
figure,imshow(f1), title(['Downsampled by ' num2str(M) ' after prefiltering'])
f1 = imresize(f1,[Height,Width],'bicubic');
figure,imshow(f1(60:275,302:585))
title('Reconstructed from downsampled image: with prefiltering')