% Example2_3.m
% convert rectangular to hexagonal grid

clear
close all
M = 256; N = 256;
f = uint8(zeros(N,N));
g = uint8(zeros(M+N,M+N));
% create an image with alternating black & white dots
% for visibility sake, these are R/2xR/2 squares
%
R = 2; % pixel replication factor
for k = 1:R:M
    for l = 1:R:N
        for k1 = 1:R/2
            for l1 = 1:R/2
                f(k+k1-1,l+l1-1) = 255;
            end
        end
    end
end
figure,imshow(f), title('Rectangular grid')
Fig1 = figure;
imshow(f), title('Rectangular grid')
zoom(Fig1,4)
%
% rectangular to hexagonal transformation
V = [1 1; 1 -1];
for n1 = 1:M
    for n2 = 1:N
        t1 = V(1,1)*n1 + V(1,2)*n2;
        t2 = V(2,1)*n1 + V(2,2)*n2;
        g(513-t1,256+t2) = f(n1,n2);
    end
end
figure,imshow(g), title('Hexagonal grid')
g1 = imcrop(g,[130 130 230 230]);
Fig2 = figure;
imshow(g1), title('Hexagonal grid')
zoom(Fig2,4)
