% Example2_4.m
% convert rectangular to hexagonal grid
% using linear transformation 
% Sample spacing is DX in the row dimension
% and DY in the column dimension
% transformation is [t1 t2]' = V*[n1 n2]';
% where V = [DX DY; DX -DY];
% In our example we assume DX = DY = 1;
clear
close all
%A = imread('cameraman.tif');
A = imread('barbara.tif');
%{
[M,N,D] = size(A);
N2 = 2*N;
M2 = 2*M;
%}
D = 3;
M = 216; N = 284; M2 = 2*M; N2 = 2*N;
%M = 164; N = 205; M2 = 2*M; N2 = 2*N;
if D > 1
    %f = A(:,:,1);
    f = A(60:275,302:585,1);
    %f = A(182:345,76:280,1);
else
    f = A;
end
figure,imshow(f), title('Rectangular grid')
g = uint8(zeros(M+N,M+N));% transformed image twice as big as the input
%
% Convert rectangular to hexagonal sampling
V = [1 1; 1 -1]; % rectangular to hexagonal transformation
for n1 = 1:M
    for n2 = 1:N
        t1 = V(1,1)*n1 + V(1,2)*n2;
        t2 = V(2,1)*n1 + V(2,2)*n2;
        g(t1,N+t2) = f(n1,n2);
    end
end
figure,imshow(g'),title('Hexagonal grid')
% Now revert to rectangular grid
VI = inv(V);
f1 = uint8(zeros(M+N,M+N));
for t1 = 2:M+N
    %for t2 = -N+1:N-1
    for t2 = -N+1:M-1
        n1 = floor(VI(1,1)*t1 + VI(1,2)*t2);
        n2 = floor(VI(2,1)*t1 + VI(2,2)*t2);
        %f1(n1+M/2,n2+N/2) = g(N2+1-t1,M+t2);
        %f1(n1+round((N-1)/2),n2+round((M-1)/2)) = g(N2+1-t1,M+t2);
        f1(n1+round((N-1)/2),n2+round((M-1)/2)) = g(M+N+1-t1,N+t2);
    end
end
% image is flipped right and down
f1 = f1';
%f1(:,1:N2) = f1(:,N2:-1:1);
f1(:,1:M+N) = f1(:,M+N:-1:1);
f1(1:M+N,:) = f1(M+N:-1:1,:);
figure,imshow(f1(round(N/2)+2:round(N/2)+M+1,round(M/2)+2:round(M/2)+N+1))
title('Rectangular grid')

