function R = AutoCorrelation(x,N)
% computes the covariance matrix of x 
% x is the input image and
% R is the N x N covariance matrix of x

Meanf = zeros(1,N);
R = zeros(N,N);
[Height,Width] = size(x);
for n = 1:N:Width
    for k = 1:N
        Meanf(k) = Meanf(k) + sum(x(:,n+k-1));
    end
end
for m = 1:Height
    for n = 1:N:Width
        b = (x(m,n:n+N-1)-Meanf)'*(x(m,n:n+N-1)-Meanf);
        R = R + b;
    end
end
R = R/max(R(:));