% Example3_3.m
% Computes the basis images corresponding to a given
% 2D unitary transform and size 
% and displays as images
% 
% Allowed transforms = 'DCT', 'DST', 'Hartley', 'Haar',
% 'Hadamard', and 'Slant'
%
N = 8; % N x N is the size of the unitary transform
% Only N = 8 is allowed for Haar transform
TransformType = 'DCT';
% compute the basis images by calling the 
% function BasisImages
[y,T] = BasisImages(N,TransformType); % T is the N^2 x N^2 basis images
%
X = ones(192,192) * 16; % inscribe each N x N submatrix into X
for k = 0:N-1
    rIndx = k*24 + 1;
    for l = 0:N-1
        cIndx = l*24 +1;
        MaxT = max(max(T(k*N+1:k*N+N,l*N+1:l*N+N)));
        MinT = min(min(T(k*N+1:k*N+N,l*N+1:l*N+N)));
        % normalize to between 0 & 255 for display purpose
        if k == 0
            t1 = T(k*N+1:k*N+N,l*N+1:l*N+N)/MaxT*255;
        else
            t1 = (T(k*N+1:k*N+N,l*N+1:l*N+N)-MinT)/(MaxT-MinT)*255;
        end
        T1 = imresize(t1,[16 16],'bicubic'); % exapnd matrix to 2N x 2N
        X(rIndx+3:rIndx+18,cIndx+3:cIndx+18) = T1;
    end
end
figure,imshow(X,[]),title([num2str(N) 'x' num2str(N) ' basis images for ' TransformType]);