% FastDCTImage.m
% computes the N x N DCT of an input image
% using FFT algorithm

A = imread('cameraman.tif');
x = double(A(:,:,1));% strip one of three components
%{ 
% for cropped image
Height = 256; Width = 256;
A = imread('barbara.tif');
x = double(A(59:58+Height,331:330+Width,1));
%}
figure,imshow(x,[]), title('original image')
% compute the 2D DCT of the image in blocks of 8 x 8 pixels
% by calling MATLAB function blkproc
% FastDCT computes the 2D DCT of an 8 x 8 block
% Y will be of the same size as the image x
Y = blkproc(x,[8 8],@FastDCT);
%
% now compute the inverse 2D DCT by calling again the
% MATLAB function blkproc with FastIDCT, which
% calculates the 2D inverse DCT
z = blkproc(Y,[8 8],@FastIDCT);
figure,imshow(uint8(z)),title('inverse DCT of the image')
