% ImageCorrelation.m
A = imread('barbara.tif');
Height = 256;
Width = 256;
x = double(A(59:58+Height,331:330+Width,1));% cropped image
N = 8;
%A = imread('cameraman.tif');
%x = double(A(:,:,1));
%
R = zeros(N,N);
z = zeros(N,N);
z1 = zeros(1,N);
%
Meanfc = zeros(1,N);
Meanfr = zeros(1,N);
for r = 1:N:Height
    for c = 1:N:Width
        z = x(r:r+N-1,c:c+N-1);
        Meanfc = Meanfc + [z(1,1) z(2,2) z(3,3) z(4,4) z(5,5) z(6,6) z(7,7) z(8,8)];
        Meanfr = Meanfr + [z(N,1) z(N-1,2) z(N-2,3) z(N-3,4) z(N-4,5) z(N-5,6) z(N-6,7) z(N-7,8)];
        
    end
end
Meanfc = floor(Meanfc/(Height*Width/(N*N))); 
Meanfr = floor(Meanfr/(Height*Width/(N*N)));
%
b = zeros(N,N);
for r = 1:N:Height
    for c = 1:N:Width
        z = x(r:r+N-1,c:c+N-1);
        z1 = [z(1,1) z(2,2) z(3,3) z(4,4) z(5,5) z(6,6) z(7,7) z(8,8)];
        b = (z1-Meanfc)'*(z1-Meanfc);
        R = R + b;
    end
end
%
R = R/max(R(:));
[EVc,Evalc] = eig(R);
EVc = EVc(:,N:-1:1);
EVc = EVc(N:-1:1,:);
%
for r = 1:N:Height
    for c = 1:N:Width
        z = x(r:r+N-1,c:c+N-1);
        %z1 = [z(1,N) z(2,N-1) z(3,N-2) z(4,N-3) z(5,N-4) z(6,N-5) z(7,N-6) z(8,N-7)];
        z1 = [z(N,1) z(N-1,2) z(N-2,3) z(N-3,4) z(N-4,5) z(N-5,6) z(N-6,7) z(N-7,8)];
        b = (z1-Meanfr)'*(z1-Meanfr);
        R = R + b;
    end
end
R = R/max(R(:));
[EVr,Evalr] = eig(R);
EVr = EVr(:,N:-1:1);
EVr = EVr(N:-1:1,:);
%
X = ones(192,192) * 16; % inscribe each N x N submatrix into X
T2 = zeros(N*N,N*N);
for k = 0:N-1
    rIndx = k*24 + 1;
    rInd = k*N + 1;
    for l = 0:N-1
        cIndx = l*24 +1;
        cInd = l*N +1;
        %y = EVc(:,k+1) * EVr(:,l+1)';
        y = EVr(:,k+1) * EVc(:,l+1)';
        T = y;
        T2(rInd:rInd+N-1,cInd:cInd+N-1) = y;
        if k == 0
            T = T/max(T(:))*255;
        else
            T = (T-min(T(:)))/(max(T(:))-min(T(:)))*255;
        end
        T1 = imresize(T,[16 16],'bicubic'); % exapnd matrix to 2N x 2N
        X(rIndx+3:rIndx+18,cIndx+3:cIndx+18) = T1;
    end
end
figure,imshow(X,[]),title([num2str(N) 'x' num2str(N) ' basis images for KLT'])
x1 = zeros(N,N);
x2 = zeros(Height,Width);
mse = zeros(N,N);
for m = 0:N-1   % take each basis image along rows
    mInd = m*N + 1;
    for n = 0:N-1   % take each basis image along columns
        nInd = n*N + 1;
        for r = 1:N:Height % take N rows at a time
            for c = 1:N:Width   % take N columns at a time
                %x1 = EVc'*double( x(r:r+N-1,c:c+N-1))*EVr;
                x1 = EVr'*double( x(r:r+N-1,c:c+N-1))*EVc;
                sum1 = x2(r:r+N-1,c:c+N-1);
                x2(r:r+N-1,c:c+N-1) = sum1 +...
                    x1(m+1,n+1) * T2(mInd:mInd+N-1,nInd:nInd+N-1);
            end
        end
        
        if (m == 0 && n == 0) || (m == 1 && n == 4)
            figure,imshow(x2,[])
            title(['No. of basis images used = ' num2str(m*N+n+1) ])
        end
        mse(m+1,n+1) = (std2(double(x) - x2)) ^2;
        
    end
end 
figure,imshow(x2,[])
figure,plot(0:N^2-1,[mse(1,:) mse(2,:) mse(3,:) mse(4,:) mse(5,:) mse(6,:)...
    mse(7,:) mse(8,:)],'k:','LineWidth',2)