% Example4_1.m
% Computes 1D DWT of a sequence f[n] up to 2 levels
% and plots the DWT coefficients
% specify the name of the wavelet in "WaveletName"
% f[n] = A1xsin(2*pi*F1*n) + A2xcos(2*pi*F2*n)
%
WaveletName = 'db8';
n = 0:99; % sequence length
A1 = 2.0; A2 = 1.5; % amplitudes of the two sinusoids
F1 = 0.1; F2 = 0.2; % frequencies normalized to sampling frequency
f = A1*sin(2*pi*F1*n) + A2*cos(2*pi*F2*n);
% compute level 1 DWT of f[n], which consists of the
% approximation coefficients "a1" and detail 
% coefficients "d1."
[a1,d1] = dwt(f,WaveletName);
figure,subplot(3,1,1),plot(n,f,'k','LineWidth',1);
title('Input signal f[n]')
subplot(3,1,2),plot(a1,'k','LineWidth',1)
title('DWT of f[n]:Level-1 scaling coefficients')
subplot(3,1,3),plot(d1,'k','LineWidth',1)
title('Level-1 detail coefficients')
% Next, compute level 2 DWT of a1, the level 1 approximation
[a2,d2] = dwt(a1,WaveletName);
figure,subplot(2,1,1),plot(a2,'k','LineWidth',1)
title('level-2: scaling coefficients')
subplot(2,1,2),plot(d2,'k','LineWidth',1)
title('Level-2 detail coefficients')
