function DecodedSymbol = ArithmeticDecode(CDF,Tag,L)
% DecodedSymbol = ArithmeticDecode(m)
% Given the CDF, TAG, and the length of the
% symbol sequence, the function returns the
% symbol sequence in "DecodedSymbol"
%
Low = 0; High = 1; % initialize lower & upper intervals
DecodedSymbol = int16(zeros(1,L));
k = 1;
while k <= L
    T = (Tag - Low)/(High-Low);
    for j = 1:length(CDF)
        if j == 1
            if T>=0 && T<CDF(j)
                DecodedSymbol(k) = j;
                break
            end
        else
            if T>=CDF(j-1) && T<CDF(j)
                DecodedSymbol(k) = j;
                break
            end
        end
    end
    if DecodedSymbol(k) == 1
        Lower= Low;
    else
        Lower = Low + (High-Low)*CDF(DecodedSymbol(k)-1);
    end
    Higher = Low + (High-Low)*CDF(DecodedSymbol(k));
    Low = Lower; High = Higher;
    k = k + 1;
end