function Tag = ArithmeticEncode(CDF,m)
% Tag = ArithmeticEncode(p)
% Arithmetic coding procedure
% p is the probability vector of the source alphabet
% m is the symbol sequence to be coded
% CDF is the cumulative distribution


Low = 0; High = 1; % initial values of lower & upper intervals
%l and u are the next lower & upper intervals
k = 1;
while k <= length(m)
    if m(k) == 1
        Lower = Low;
    else
        Lower = Low + (High-Low)*CDF(m(k)-1);
    end
    Upper = Low + (High-Low)*CDF(m(k));
    Tag = (Upper+Lower)/2;
    Low = Lower; High = Upper;
    k = k + 1;
end