% Example5_4.m
% Program to generate Huffman codes for the
% given probability vector p
% The Huffman codes and the corresponding code lengths are
% stored in the arrays HC and L, respectively.

%p = [1/8 1/4 1/10 1/10 1/16 1/16 1/12 13/60];
p = [.25 .25 .125 .125 .0625 .0625 .0625 .0625];
%p = [.2 .15 .13 .12 .1 .09 .08 .13];
%p = [.4 .2 .1 .3];
%p = [1/2 1/4 1/8 1/16 1/16];
% Check for negative value for any probability and
% if the sum of the probabilities do not add up to 1.
if any(find(p<0))
    error('Negative value for probability\n')
end
if abs(sum(p)-1) >1.0e-10
    error('Not a valid probability set\n')
end
% Compute the source entropy.
H = sum(-p .* log2(p+1e-08));
sprintf('Source Entropy = %5.2f\n',H)
% Call the function Huffman to generate the Huffman codes.
[HC,L] = Huffman(p);
% Compute the average code length of the Huffman codes.
AvgLength = sum(p.*double(L));
% compute the Huffman code efficiency as the ratio of entropy to
% the average code length. 
E = 100*H/AvgLength;
sprintf('Average Code Length = %5.2f\n',AvgLength)
sprintf('Efficiency = %5.2f%%\n',E)