%Example5_6.m
%   Encode the differential image using Golomb-Rice
%   coding.

A = imread('twy010.ras');% read frame #n
B = imread('twy011.ras');% read frame #n+1
%
FileNames = {'twy010.ras' 'twy011.ras'};
montage(FileNames)% function Montage displays the two
% image frames side by side in a single window.
%
% compute the differential frame = frame #(n+1) - frame #n
E = double(B)-double(A);
%
% compute the histogram of the differential image
[H1,Bin1] = hist(E(:),max(E(:))-min(E(:))+1);
H1 = H1/sum(H1);% normalize the count
%
E1 = zeros(size(A));% array to stotre the mapped values
% map all negative values to odd positive integers
[y,x] = find(E<0);
for i = 1:size(x,1)
    E1(y(i),x(i)) = 2*abs(E(y(i),x(i)))-1;
end
clear x y;
% map all positive values to even positive integers
[y,x] = find(E>=0);
for i = 1:size(x,1)
    E1(y(i),x(i)) = 2*E(y(i),x(i));
end
% determine m = 2^k
k = ceil(log10(mean(E1(:)))/log10(2));
m = 2^k;
% compute the histogram of the mapped differential image
N = max(E1(:)) + 1;
[H,Bin] = hist(E1(:),N);
H = H/sum(H);
figure, subplot(2,1,1),plot(Bin1,H1,'k')
title('Histogram of the differential image')
ylabel('normalized count')
subplot(2,1,2),plot(Bin,H,'k')
title('Histogram of mapped differential image')
xlabel('pixel value')
ylabel('normalized count')
% compute the average length of GR code = k+floor(n/m)+1
AvgCodeLn = sum((floor(Bin/m)) .* H)+k+1;
sprintf('Average Golomb-Rice Code length = %3.2f\n',AvgCodeLn)
sprintf('Entropy = %3.2f\n',sum(-H1 .* log2(H1+1.0e-10)))
sprintf('Efficiency = %3.2f\n',(sum(-H1 .* log2(H1+1.0e-10))/AvgCodeLn*100))