                                                                                                                             function [HC,L] = Huffman(p)
% [HC,L] = HUFFMAN(p)
% Generates Huffman codes for input symbols
% with a given probability distribution p
% The Huffman Codes are stored in the array HC
% The code lengths are stored in the array L


M = length(p);
N = M;
A = zeros(1,N-2);
p1 = sort(p,'descend');
% Part I of the code generation
for i = 1:N-2
    p1(M-1) = p1(M-1) + p1(M);
    s = find(p1(M-1) >= p1(1:M-2)); 
    %s = find(p1(M-1) >= p1(1:M-1));
    if ~isempty(s)
        loc = s(1);
    else
        loc = M-1;
    end
    T = p1(M-1);
    for k = M-2:-1:loc
        p1(k+1) = p1(k);
    end
    p1(loc) = T;
    A(N-2-i+1) = loc;
    M = M - 1;
end
% Part II of the code generation
HC = uint16(zeros(1,N));
L = uint16(ones(1,N));
HC(2) = 1;
M = 2; j = 1;
while j <= N-2
    T = HC(A(j));
    T1 = L(A(j));
    for k = A(j):M-1
        HC(k) = HC(k+1);
        L(k) = L(k+1);
    end
    HC(N) = 0;
    HC(M) = T;
    L(M) = T1;
    HC(M) = bitshift(HC(M),1);
    HC(M+1) = HC(M) + 1;
    L(M) = L(M) + 1;
    L(M+1) = L(M);
    M = M + 1;
    j = j +1;
end   