% RDfunction.m
% Rate-Distortion function for zero-mean
% Gaussian random variables
% R(D) = 0.5 log2(sig. var/D)
% where sig. var = variance of signal and
% D is the distortion between original and
% reconstructed signals.
% With R as the variable, D(R) = sig.var * 2^(-2R)

R = 0:0.25:10;
D = 2 .^ (-2*R);
plot(R,D,'k','LineWidth',2)
title('Normalized Distortion Vs Rate')
xlabel('Rate (bits/sample)')
ylabel('Distortion normalized to signal variance')
%
SNR = 1:0.25:20;
Rate = 0.5*log2(SNR);
figure,plot(SNR,Rate,'k','LineWidth',2)
title('Rate Vs SNR')
xlabel('SNR')
ylabel('Rate (bits/sample')

