function [RL,Level] = RLC(x)
% [RL,Level] = RLC(x)
% Run-length coding of a quantized DCT block
% DCT block size = 8 x 8
% Maximum possible length of zero run = 63
% DC coefficient is excluded
% Input 2D array x is the quantized DCT block
% Vector RL returns the lengths of runs in
% the positions corresponding to where the
% zero run starts in the zigzag scan of x
% Vector Level returns the non-zero coefficient
% that broke the zero run


% zigzag scan the 8 x 8 DCT blocks
y = ZigZag(x);
RL = int16(zeros(1,64));
Level = int16(zeros(1,64));
k = 2; Count = 0; l = 0;
%%%%%%%%%%%%% need to fix EOB **************
while k <= 64
    if y(k) == 0
        Count = Count + 1;
        l = l + 1;
    else
        if Count ~= 0
            RL(k-l) = Count;
            Level(k-l) = y(k);
            Count = 0;
            l = 0;
        end
    end
    k = k + 1;
end       