function H = SourceEntropy(x)
%   H = SourceEntropy(x)
% computes the entropy of the input intensity image x
% input image is assumed to be of type uint8


[Height,Width] = size(x);
[p,Binx] = imhist(x);% compute the histogram with 256 bins.
%
p = p/(Height*Width);% normalize the histogram counts.
sprintf('Sum of hist. values = %g',sum(p))% verify that sum(p) = 1
figure,plot(Binx,p,'k')
xlabel('Pixel value'), ylabel('relative count')
% to avoid log(0), add a small positive value to p.
H = sum(-p .* log2(p+1e-08));% compute the entropy