function y = ChangeSampleRate(x,R,Type)
% y = ChangeSampleRate(x,R,Type)
% Input:
%   x = image to be sampled
%   R = 0 for sampling in both dimensions or 2 for sampling
%   in horizontal dimension only
%   Type = 'down' for down sampling or 'up' for upsampling

[Height,Width] = size(x);
switch Type
    case 'down'
        h = Design2Dfilter(9);
        t = imfilter(x,h,'symmetric','same');
        switch R
            case 0
                y = t(1:2:Height,1:2:Width);
            case 2
                y = t(:,1:2:Width);
        end
    case 'up'
        h = Design2Dfilter(21);
        y = zeros(2*Height,2*Width);
        switch R
            case 0
                y(1:2:2*Height,1:2:2*Width) = x;
                y = imfilter(y,h,'symmetric','same');
             case 2
                 y(:,1:3:Width) = x;
                 y = imfilter(y,h,'symmetric','same');
        end
end
             