%   Example7_1.m
%   Computes transform quantizer bits optimally using
%   the rule: R(k) = R +0.5*log2(var of kth coeff./geometric variance)
% isotropic covariance model r(m,n) = sig^2 exp(-|a|sqrt(m^2+n^2))



clear
A = imread('cameraman.tif');  % read an image
[Height,Width,Depth] = size(A);
%
if Depth == 1
    A1 = double(A);
else
    A = double(rgb2ycbcr(A));
    A1 = A(:,:,1);
end
A = A1;
clear A1
R = 1.0; % Bit budget in bpp
N = 8; % Transform matrix size
% call function AllocateBits to determine quantizer optimal bits
Qbits = AllocateBits(A,R,N);
%
sprintf('Optimal quantizer bits\n')
disp(Qbits)
sprintf('Desired avg. rate = %3.2f bpp\tActual avg. rate = %3.2f bpp\n',R,sum(Qbits(:))/(N*N))

