% Example7_2.m
% Calculate the coding gain of a DCT coder
% for transform sizes of 4 x 4, 8 x 8, 16 x 16 and
% 32 x 32 pixels.
% The function "TCgain" calculates the coding gain in dB

clear
fileName = 'cameraman.tif';
A = imread(fileName);
[Height,Width,Depth] = size(A);
%
if Depth == 1
    A1 = double(A);
else
    A = double(rgb2ycbcr(A));
    A1 = A(:,:,1);
end
figure,imshow(A1,[]), title(fileName)
N = 4;
for j = 1:4
    %G = TCgain(A1,N);
    G = TCgain(A1,N);
    sprintf('Coding Gain for %dx%d DCT = %4.2f\n',N,N,G)
    N = 2*N;
end