% Example7_5.m
% Implements an algorithm to remove blockiness
% due to JPEG compression. First the quantized DCT
% coefficients are adjusted for minimum MSE based on
% the Laplacian PDF of the AC coefficients. Second,
% the reconstructed pixels are classified based on
% block boundary variance and the block edge pixels 
% exceeding a threshold are smoothed

clear
%A = imread('birds.ras');  % read an image
A = imread('masuda2.ras');
[Height,Width,Depth] = size(A);
%
N = 8; % Transform matrix size
% Limit the Height & Width of the input image to multiples of N
if mod(Height,N)~= 0
    Height = floor(Height/N)*N;
end
if mod(Width,N)~= 0
    Width = floor(Width/N)*N;
end
A1 = A(1:Height,1:Width,:);
clear A
A = A1;
% If the input image is an RGB image, convert it to YCbCr image
if Depth == 1
    A1 = double(A);
else
    A = double(rgb2ycbcr(A));
    A1 = A(:,:,1);
end
% Call deBlocking function with a scale factor of 3
xq = deBlockingArt(A1,3);
figure,imshow(xq,[])