% Example7_6.m
% Uses varibale size DCTs to compress an image
% Image is divided into variable size subblocks
% using quad tree decomposition. Each subblock is
% DCT transformed, quantized, dequantized, and
% inverse DCT transformed to reconstruct the image.
% Use of variable size DCT eliminates blocking
% artifact that happens with fixed size DCT.
% Minimum block size is 2 x 2
% maximum block size is 16 x 16


clear
A = imread('masuda2.ras');
%A = imread('cameraman.tif');
[Height,Width,Depth] = size(A);
% If image height & width are not multiples of 16,
% limit them to multiples of 16 smaller than the
% image dimensions.
if mod(Height,16)~= 0
    Height = floor(Height/16)*16;
end
if mod(Width,16)~= 0
    Width = floor(Width/16)*16;
end
A1 = A(1:Height,1:Width,:);
clear A
A = A1;
% If the input image is an RGB image, convert it to YCbCr image
if Depth == 3
    A = rgb2ycbcr(A);
    A1 = A(:,:,1);
end
clear A
A = A1;
% Invoke the function "varSizeDCTcoder with
% Thresh = 0.12 and Qscale = 2.
y = varSizeDCTcoder(A,0.12,2);