function Qbits = ModelBits(A,R,N)


[Height,Width,Depth] = size(A); % Height, Width & Depth of the image
if Depth > 1
    A1 = double(A(:,:,1));
else
    A1 = double(A);
end
%
D1 = Height/N;
D2 = Width/N;
v1 = zeros(Height*D2,N);
v2 = zeros(D1*Width,N);
for m = 1:Height
    for n = 1:N:Width
        n1 = floor(n/N)+1;
        v1((m-1)*D1+n1,1:N) = A1(m,n:n+N-1);
    end
end
for n = 1:Width
    for m = 1:N:Height
        m1 = floor(m/N)+1;
        v2((n-1)*D2+m1,1:N) = A1(m:m+N-1,n);
    end
end
R1 = cov(v1);
R2 = cov(v2);
%
y1 = diag(dct2(R1));
y2 = diag(dct2(R2));
CoefVar = y1 * y2';
% geometric mean of the coef. variances
N2 = N*N;
P1 = CoefVar .^ (1/N2);
GeoMeanOfVar = prod(P1(:));
Qbits = zeros(N,N);
for k = 1:N
    for l = 1:N
        b = R + 0.5*log2(CoefVar(k,l)/GeoMeanOfVar);
        if b <= 0
            Qbits(k,l) = 0;
        else
            Qbits(k,l) = round(b);
        end        
    end
end
sprintf('Optimal quantizer bits\n')
disp(Qbits)
sprintf('Desired avg. rate = %3.2f bpp\tActual avg. rate = %3.2f bpp\n',R,sum(Qbits(:))/N2)