function G = TCgain(x,N)
% G = TCgain(x,N)
%   computes the coding gain of the 2D DCT coder
% Input:
%   x = intensity image
%   N = size (assumed square) of the transform block
% Output:
%   G = coding gain over PCM in dB


[Height,Width] = size(x);
Y = blkproc(x,[N N],@dct2);   % do N x N 2D DCT
%   compute the DCT coefficient variance
CoefVar = zeros(N,N);
for i = 1:N
    for j = 1:N
        t = std2(Y(i:N:Height,j:N:Width));
        CoefVar(i,j) = t * t;
    end
end

%
MeanVar = mean(CoefVar(:));
P1 = CoefVar .^ (1/(N^2));
GeoMeanVar = prod(P1(:)); % geometric mean of the coef. variances
G = 10*log10(MeanVar/GeoMeanVar); % coding gain