function Bits = dcBits(x)
% Bits = dcBits(x)
% # bits used to code the DC differential
% Input:
% x = differential value of the DC coefficient of a DCT block
% Output:
% Bits = number of bits used to code the differential DC value
%
x1 = abs(x);
if x1 == 0
    Bits = int32(0);
elseif x1 >= 1 && x1 < 2
    Bits = 1;
elseif x1 >= 2 && x1 < 4
    Bits = int32(2);
elseif x1 >= 4 && x1 < 8
    Bits = int32(3);
elseif x1 >= 8 && x1 < 16
    Bits = int32(4);
elseif x1 >= 16 && x1 < 32
    Bits = int32(5);
elseif x1 >= 32 && x1 < 64
    Bits = int32(6);
elseif x1 >= 64 && x1 < 128
    Bits = int32(7);
else
    Bits = int32(8);
end
Bits = int32(2)*Bits;