function y = dst(x,N)
% y = dst(x,N)
% Discrete Sine Transform of an image block
% Input:
%   x = N x N block
% Output:
%   y = discrete sine transform of x

% kernel matrix of N x 1 sine transform
T = zeros(N,N);
for n = 0:N-1
    for k = 0:N-1
        T(n+1,k+1) = sin(pi*(n+1)*(k+1)/(N+1));
    end
end
T = T*sqrt(2/(N+1));
y = T * x * T;