function [Qbits,Qsteps] = AssignIntgrBits2DWT(C,S,wName,R)
%   Assigns DWT coefficient quantizer bits optimally using
%   recursive integer bit allocation rule.


L = size(S,1) - 2;
Coef = cell(3*L+1,1);
Rtotal = (3*L+1)*R;   % total bits for the N x N block
j = 1;
for k = 1:L
    [Coef{j},Coef{j+1},Coef{j+2}] = detcoef2('all',C,S,k);
    j = j+3;
end
Coef{3*L+1} = appcoef2(C,S,wName,L);
CoefVar = zeros(3*L+1,1);
for k = 1:L
    k1 = (k-1)*3;
    for j = 1:3
        CoefVar(k1+j) = std2(Coef{k1+j})*std2(Coef{k1+j});
        if CoefVar(k1+j) == 0
            CoefVar(k1+j) = 1;
        end
    end
end
CoefVar(3*L+1) = std2(Coef{3*L+1})*std2(Coef{3*L+1});
Qbits = zeros(3*L+1,1);
%
while Rtotal > 0
    Max = -9999;
    for k = 1:3*L+1
        if Max < CoefVar(k)
                Max = CoefVar(k);
                Indx = k;
        end
    end
    Qbits(Indx) = Qbits(Indx) + 1;
    CoefVar(Indx) = CoefVar(Indx)/2;
    Rtotal = Rtotal - 1;
end
Qsteps  = zeros(3*L+1,1);
for k = 1:3*L+1
    maxCoef = max(max(Coef{k}));
    D = maxCoef;
    if D ~= 0
        Qsteps(k) = D/(2*2^Qbits(k));
    else
        Qsteps(k) = 1.0e+16;
    end
end