function y = deadzoneDWT(C,S,Qsteps,wName)


L = size(S,1) - 2; % number of DWT levels
% extract the DWT coefficients
appCoefLength = S(1,1)*S(1,2); % length of app coef.
for k = 1:L
    k1 = (k-1)*3+1;
    k2 = k1 +2;
    detCoefLength(k1:k2) = S(k+1,1)*S(k+1,2);
end
Q = 'det';
switch Q
    case 'all'
        temp = C(1:appCoefLength);
        temp = floor(temp/Qsteps(3*L+1)+0.5)*Qsteps(3*L+1);
        Cq(1:appCoefLength) = temp;
        startLoc = appCoefLength;
        for k = 1:3*L
            temp = C(startLoc+1:startLoc+detCoefLength(k));
            Indx1 = find((temp >= -Qsteps(k)/2) & (temp<Qsteps(k)/2));
            Indx2 = find((temp < -Qsteps(k)/2) | (temp>=Qsteps(k)/2));
            temp(logical(Indx1)) = 0;
            temp(Indx2) = floor(temp(Indx2)/Qsteps(k)+0.5)*Qsteps(k);
            Cq(startLoc+1:startLoc+detCoefLength(k)) = temp;
            startLoc = startLoc + detCoefLength(k);
        end
    case 'L1'
        temp = C(1:appCoefLength);
        Cq(1:appCoefLength) = temp;
        startLoc = appCoefLength;
        for k = 1:3*L
            if k <= 3
                temp = C(startLoc+1:startLoc+detCoefLength(k));
                Indx1 = find((temp >= -Qsteps(k)/2) & (temp<Qsteps(k)/2));
                Indx2 = find((temp < -Qsteps(k)/2) | (temp>=Qsteps(k)/2));
                temp(logical(Indx1)) = 0;
                temp(Indx2) = floor(temp(Indx2)/Qsteps(k)+0.5)*Qsteps(k);
            else
                temp = C(startLoc+1:startLoc+detCoefLength(k));
            end
            Cq(startLoc+1:startLoc+detCoefLength(k)) = temp;
            startLoc = startLoc + detCoefLength(k);
        end
    case 'det'
        temp = C(1:appCoefLength);
        Cq(1:appCoefLength) = temp;
        startLoc = appCoefLength;
        for k = 1:3*L
            temp = C(startLoc+1:startLoc+detCoefLength(k));
            Indx1 = find((temp >= -Qsteps(k)/2) & (temp<Qsteps(k)/2));
            Indx2 = find((temp < -Qsteps(k)/2) | (temp>=Qsteps(k)/2));
            temp(logical(Indx1)) = 0;
            temp(Indx2) = floor(temp(Indx2)/Qsteps(k)+0.5)*Qsteps(k);
            Cq(startLoc+1:startLoc+detCoefLength(k)) = temp;
            startLoc = startLoc + detCoefLength(k);
        end
end
% reconstruct the image
y = waverec2(Cq,S,wName);
    
    